/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package jmednafen;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import javax.swing.JOptionPane;

/**
 *
 * @author moises
 */
public class CommandLauncher 
{
    public final static int USE_ROM_NAME = 0;
    public final static int DONT_USE_ROM_NAME = 1;
    public static void run ( String mednafen , String game , ArrayList<String> options , String tmp_path , int command_format , int use_rom_name )
    {
        String command;
        command = "\"" + mednafen + "\" ";
        
        switch ( command_format )
        {
            case 1:
                    // mednafen GAME OPTIONS
                    if ( use_rom_name == USE_ROM_NAME )
                    {
                        command += " \"" + game + "\"";
                    }
                    break;
            default:
                        break;
        }
        
        for ( int i = 0; i < options.size (); i++ )
        {
            if ( !options.get ( i ).equals ( "" ) && !options.get ( i ).equals ( " " ) )
            command += " " + options.get ( i );
        }
        
        switch ( command_format )
        {
            case 0:
                    // mednafen OPTIOINS GAME
                    if ( use_rom_name == USE_ROM_NAME )
                    {
                        command += " \"" + game + "\"";
                    }
                    break;
        }
        
        if ( !FileCreator.createLauncherScript ( command , tmp_path ) )
        {
            return;
        }
        
        ProcessBuilder pb;
        
        if ( File.separator.equals ( "/" ) )
        {
             pb = new ProcessBuilder ( "sh" , tmp_path );
        }
        else
        {
            pb = new ProcessBuilder ( tmp_path );
        }
        
        try
        {
            System.out.println ( "Launching command: " + command );
            pb.start ();
        }
        catch ( IOException e )
        {
            JOptionPane.showMessageDialog ( null , "Error launching command to run Mednafen. Try checking the Mednafen path and try again." , "Error launching Mednafen" , JOptionPane.ERROR_MESSAGE );
        }
    }
}
